;  Lines.asm - Lines for Prosit
;  (c) 1999, Franois Revol - revol@esisar.inpg.fr
;  Enjoy ;-)
;  GUI skeleton taken from torus demo.

;history:
;V0.1	28/07/99
;first version for Prosit 0.64
;status: OK
;
;V0.2	30/07/99
;Changed for Prosit v0.66
;status: not finished
;
;V1.0	04/09/99
;for Prosit V0.70.1
; - No functional changes
;status: OK
;
;todo next time:
; - remove Fline/Fline0 and use doorsos::WinLine
; - strip DEBUG stuff (doesn't enlarge the prg, but the source is ugly...)
;


;The buttons:
;  +--------++-+  +--++--+  +--++--+  +--++--+
;  |  Quit  ||!|  |L-||L+|  |P-||P+|  |S-||S+|
;  +--------++-+  +--++--+  +--++--+  +--++--+
;  Guess...  Info*   Polys     Points    Speed (more
; or less BREAK_AND_COOPERATEs,since we cannot sleep for a period)
; *: +reset vectors

	include		"calc.h"

;        include		"doorsosx.h"
; from doorsos.h_not_used: maybe I don't have the last version of DoorsOs...
A_REVERSE		equ	$0000
A_NORMAL		equ	$0001
A_XOR			equ	$0002
A_SHADED		equ	$0003
A_REPLACE		equ	$0004
A_OR			equ	$0005
A_AND			equ	$0006
A_THICK1		equ	$0007
B_NORMAL		equ	$0010
B_ROUNDED		equ	$0020
B_DOUBLE		equ	$0040
B_CUT			equ	$0080
        include		"doorsos.h"
	include		"macros.h"
	include		"hexlib.h"
	include		"userlib.h"
	include		"prosit.h"
	include		"winlib.h"
	include		"keycodes.h"

	xdef		_prosit
	xdef    	_main
	xdef		_exit
	xdef		_comment

; Some debug stuff
DEBUG			EQU	1
NODEBUG			EQU	2

DEBUG_LEVEL		EQU	NODEBUG

SHOW_INFOS		EQU	1	;1 to view copyrights

WordWidth equ   14

; On the 89, the buttons were out of the screen...

 ifeq Calculator-TI92Plus
WIN1_W                  EQU     8*WordWidth
WIN1_H                  EQU     107
WIN1_X                  EQU     SCREEN_WIDTH-WIN1_W-20
WIN1_Y                  EQU     5
 endif
 ifeq Calculator-TI89
WIN1_W                  EQU     8*WordWidth
WIN1_H                  EQU     87
WIN1_X                  EQU     SCREEN_WIDTH-WIN1_W-20
WIN1_Y                  EQU     5
 endif

BUTTONS                 EQU     8
BUT_W                   EQU     12
BUT_W2                  EQU     25
BUT_H			EQU	9
BUT_S			EQU	BUT_H+1

; Here, we define the maximum displacement
; of a point from a polygon to the next

VECT_MAX		EQU	7

; Here, we define the maximum number of polygons, and of points in polygons
; and so the size of the buffer 'poly_table' (either could be much greater, 
; but i doubt it could be more interesting: we cannot see anything with more
; than 6 points, maybe for the polys...)

MAX_POINTS		EQU	10
MAX_POLYS		EQU	20

;MAX_POINTS		EQU	6
;MAX_POLYS		EQU	8

; Some used constants

POLY_LEN		EQU	2*2*MAX_POINTS
POLYTABLE_SIZE		EQU	MAX_POLYS*MAX_POINTS		;(in longs)

POLYORG_X		EQU	WIN1_W/2
POLYORG_Y		EQU	WIN1_H/2
POLY_ORIGIN		EQU	(POLYORG_X*65536+POLYORG_Y)

; The speed 
SPEED_DFLT		EQU	5
SPD_LIMIT		EQU	50

PCLIP_X1		EQU	2
PCLIP_Y1		EQU	1
PCLIP_X2		EQU	WIN1_W-3
PCLIP_Y2		EQU	WIN1_H-20

_prosit:
	HEADER_BEGIN
	DEFINE_PROSIT_VERSION	PROSIT_VERSION_STRING
	DEFINE_PROSIT_FILETYPE	PROSIT_FILETYPE_PROGRAM
	DEFINE_PROSIT_STACKSIZE	600
	DEFINE_PROSIT_EVENT	"quit",Event_Quit
	HEADER_END

_main:
	move.b		#0,Window1+W_FLAGS
	move.b		#0,Window1+W_PRIORITY
	pea		window1(pc)			;*Structure
	move.l		#Window_Datareturn,-(sp)	;*Return
	pea		w1rect(pc)			;*Window dimensions
	move.l		#Window1,-(sp)			;*Window
	jsr		winlib::WinOpen
	lea		16(sp),sp

	tst.b		d0
	bne		_exit
		;Not enough heap ?

	lea		Window1,a6
	move.w		W_CONTENTS_HANDLE(a6),d0
	doorsos::DEREF	d0,a6

	adda.l		#4,a6				;why ?
;;;	add.l		W_Y_OFFSET_IN_CONTENTS(a0),a6	;doesn't seem to work...
	adda.l		#7*WordWidth,a6	; Jump down below the title bar
	move.l		a6,vscr

	move.w		#0,-(sp)
	move.l		#Window1,-(sp)
	jsr		doorsos::WinFont
	addq.l		#6,sp
	move.b		#A_REPLACE,Window1+W_TEXT_LINE_ATTRIBUTES

	;initialize the random seed
	;(multitasking doesn't disturb, it makes it even more "random")

	move.l		Prosit::Ticks,d0
	move.l		d0,d1
	swap.l		d1
	add.w		d1,d0
	move.w		d0,userlib::rand_seed

		;Default params

	move.w		#SPEED_DFLT,speed
	move.b		#4,pt_polycnt
	move.b		#3,pt_pntcnt
	move.b		#1,pt_head
	move.b		#4,pt_tail
	bsr		ResetPolyTable
	bsr		Calc_vectors

;	bsr		DEBUG_show_polytab

Main_Loop:
	clr.w		MouseButton

	move.l		#Window1,-(sp)		;Window
	jsr		winlib::Refresh_Window
	addq.l		#4,sp

	move.w		speed,d0
	tst.w		d0
	beq		\SP_max
\SP_loop
	BREAK_AND_COOPERATE
	dbra		d0,\SP_loop
\SP_max:

	bsr		EraseLastPoly		;erase the last poly
	;	bsr		Dec_pt_tail	;done by EraseLastPoly
	bsr		Dec_pt_head		;add a new poly
	bsr		CalcNewPoly		;calculate it
	bsr		DrawFirstPoly		;draw it
;	bsr		DEBUG_show_polytab
		; Check buttons

	move.w		MouseButton,d0

	cmp.w		#0,d0
	beq		Main_Loop

	cmp.w		#1,d0
	beq		DecPolyCount
	cmp.w		#2,d0
	beq		IncPolyCount

	cmp.w		#3,d0
	beq		DecPointCount
	cmp.w		#4,d0
	beq		IncPointCount

	cmp.w		#5,d0
	beq		DecSpeed
	cmp.w		#6,d0
	beq		IncSpeed

;	cmp.w		#7,d0
;	beq		_exit	;Doesn't work !! ??

	cmp.w		#8,d0
	beq		Show_Infos

	bra		Main_Loop


	;**********

Show_Infos:

 ifeq SHOW_INFOS-1

;	move.w		#0,-(sp)
;	move.w		#05000,-(sp)
;	move.w		#WIN1_H-20,-(sp)
;	move.w		#WIN1_W-2,-(sp)
;	move.w		#8,-(sp)
;	move.w		#1,-(sp)
;	pea		Window1
;	jsr		winlib::Box
;	lea		16(sp),sp

	move.w		#A_REVERSE,-(sp)
	pea		cl_rect
	pea		Window1
	jsr		doorsos::WinFill
	lea		10(sp),sp

	pea		info1(pc)
	move.w		#20,-(sp)
	move.w		#6,-(sp)
	move.l		#Window1,-(sp)		;Window
	jsr		doorsos::WinStrXY

	lea		info2,a0
	move.l		a0,8(sp)
	move.w		#30,6(sp)
	jsr		doorsos::WinStrXY

	lea		info3,a0
	move.l		a0,8(sp)
	move.w		#38,6(sp)
	jsr		doorsos::WinStrXY

	lea		info4,a0
	move.l		a0,8(sp)
	move.w		#46,6(sp)
	jsr		doorsos::WinStrXY
	jsr		winlib::Refresh_Window
	lea		12(sp),sp

	move.w		#10000,d0
\NICE_loop
	BREAK_AND_COOPERATE
	dbra		d0,\NICE_loop
 endif
	move.w		#A_REVERSE,-(sp)
	pea		cl_rect
	pea		Window1
	jsr		doorsos::WinFill
	lea		10(sp),sp

	bsr		Calc_vectors
	bsr		ResetPolyTable

	bra		Main_Loop
	;**********

DecSpeed:
	move.w		speed,d0
	cmp.w		#SPD_LIMIT,d0
	beq		\DS_skip
	addq.w		#1,d0
	move.w		d0,speed
\DS_skip:
	bra		Main_Loop

IncSpeed:
	move.w		speed,d0
	tst.w		d0
	beq		\IS_skip
	subq.w		#1,d0
	move.w		d0,speed
\IS_skip:
	bra		Main_Loop

	;**********

DecPolyCount:
	move.b		pt_polycnt,d0
	cmp.b		#1,d0
	beq		\DPC_skip
	subq.b		#1,d0
	move.b		d0,pt_polycnt
	bsr		EraseLastPoly		;erase the last poly
	;	bsr		Dec_pt_tail	;done by EraseLastPoly
\DPC_skip:
	bra		Main_Loop

	;**********

IncPolyCount:
	move.b		pt_polycnt,d0
	cmp.b		#MAX_POLYS-1,d0
	beq		\IPC_skip
	addq.b		#1,d0
	move.b		d0,pt_polycnt
	bsr		Dec_pt_head		;add a new poly
	bsr		CalcNewPoly		;calculate it
	bsr		DrawFirstPoly		;draw it
\IPC_skip:
	bra		Main_Loop

	;**********

DecPointCount:
		;pt_pntcnt=(pt_pntcnt > 0)?(pt_pntcnt - 1):(pt_pntcnt)
	move.b		pt_pntcnt,d0
	cmp.b		#1,d0
	beq		\DPC_nodec
	subq.b		#1,d0
\DPC_nodec:
	move.b		d0,pt_pntcnt

	move.w		#A_REVERSE,-(sp)
	pea		cl_rect
	pea		Window1
	jsr		doorsos::WinFill
	lea		10(sp),sp

	bsr		ResetPolyTable
	bra		Main_Loop

	;**********

IncPointCount:
		;pt_pntcnt=(pt_pntcnt < MAX_POINTS)?(pt_pntcnt + 1):(pt_pntcnt)
	move.b		pt_pntcnt,d0
	cmp.b		#MAX_POINTS-1,d0
	beq		\IPC_noinc
	addq.b		#1,d0
\IPC_noinc:
	move.b		d0,pt_pntcnt

	move.w		#A_REVERSE,-(sp)
	pea		cl_rect
	pea		Window1
	jsr		doorsos::WinFill
	lea		10(sp),sp

	bsr		ResetPolyTable
	bra		Main_Loop



;*******************************************************
Calc_vectors:
	movem.l		d0-d1/a0,-(sp)
	lea		vectors,a0
	move.w		#MAX_POINTS,d1
\CV_loop:
		;DX
	move.w		#2*VECT_MAX,d0
	jsr		userlib::random
	subq.w		#VECT_MAX,d0
	move.w		d0,(a0)+
		;DY
	move.w		#2*VECT_MAX,d0
	jsr		userlib::random
	subq.w		#VECT_MAX,d0
	move.w		d0,(a0)+

	dbra		d1,\CV_loop
	movem.l		(sp)+,d0-d1/a0
	rts
;*******************************************************
Dec_pt_head:
	move.w		d0,-(sp)

		;pt_head=(pt_head > 0)?(pt_head - 1):(pt_polycnt - 1)

	move.b		pt_head,d0
	tst.b		d0
	bne		\DPH_nochg
;	move.b		pt_polycnt,d0
	move.b		#MAX_POLYS,d0

\DPH_nochg:
	subq.b		#1,d0
	move.b		d0,pt_head

	move.w (sp)+,d0	
	rts

;*******************************************************
Dec_pt_tail:
	move.w		d0,-(sp)

		;pt_tail=(pt_tail > 0)?(pt_tail - 1):(pt_polycnt - 1)

	move.b		pt_tail,d0
	tst.b		d0
	bne		\DPT_nochg
;	move.b		pt_polycnt,d0
	move.b		#MAX_POLYS,d0

\DPT_nochg:
	subq.b		#1,d0
	move.b		d0,pt_tail

	move.w (sp)+,d0
	rts

;*******************************************************
ResetPolyTable:
	movem.l		d0/a0,-(sp)
	move.w		#POLYTABLE_SIZE,d0
	lea		poly_table,a0
\RPT_loop
	move.l		#POLY_ORIGIN,(a0)+
	dbra		d0,\RPT_loop
	movem.l		(sp)+,d0/a0
	rts

;*******************************************************
CalcNewPoly:
	movem.l		d0-d3/a0-a2,-(sp)
	clr.l		d3
	move.b		pt_pntcnt,d3
	lea		poly_table,a1
	move.l		a1,a2
	clr.l		d1
	move.b		pt_head,d1
	clr.l		d2
	move.b		d1,d2
	mulu		#POLY_LEN,d1
	adda.l		d1,a1		;point to first poly in buffer (the new one)

	addq.w		#1,d2
	cmp.w		#MAX_POLYS,d2
	bne		\CNP_skip1
	clr.w		d2
\CNP_skip1:
	mulu		#POLY_LEN,d2
	adda.l		d2,a2		;point to first poly in buffer (the old one)
	

	lea		vectors,a0	;point to vectors

;	bsr		DEBUG_show_regs
;	jsr		Prosit::Sleep
;	bra		\DBG_END

		; Here :
		; a0 -> vectors, a1 -> new poly, a2 -> old poly 
		; d3 = number of points to calculate


\CNP_loop:
;	bsr		DEBUG_show_regs
		;New X
	move.w		(a0)+,d0
	move.w		(a2)+,d2
	move.w		d2,d1
	add.w		d0,d1
	cmp.w		#PCLIP_X1,d1
	blt		\CNP_X_chg
	cmp.w		#PCLIP_X2,d1
	bgt		\CNP_X_chg
	bra		\CNP_X_cont
\CNP_X_chg:
	neg.w		d0
	move.w		d0,-2(a0)
	move.w		d2,d1
\CNP_X_cont:
	move.w		d1,(a1)+
;		addq.w	#4,(a1)+

		;New Y
	move.w		(a0)+,d0
	move.w		(a2)+,d2
	move.w		d2,d1
	add.w		d0,d1
	cmp.w		#PCLIP_Y1,d1
	blt		\CNP_Y_chg
	cmp.w		#PCLIP_Y2,d1
	bgt		\CNP_Y_chg
	bra		\CNP_Y_cont
\CNP_Y_chg:
	neg.w		d0
	move.w		d0,-2(a0)
	move.w		d2,d1
\CNP_Y_cont:
	move.w		d1,(a1)+
;		addq.w	#3,(a1)+
	
;	bsr		DEBUG_show_regs
	dbra		d3,\CNP_loop
;	bsr		DEBUG_show_regs
\DBG_END:
	movem.l		(sp)+,d0-d3/a0-a2
	rts

;*******************************************************
EraseLastPoly:
	movem.l		d0-d1/a0-a1,-(sp)
	

	clr.l		d4
	move.b		pt_pntcnt,d4
;######--DBG
;	subq.w		#1,d4

	lea		poly_table,a1
	move.l		a1,a2
	clr.l		d1
	move.b		pt_tail,d1
	clr.l		d2
	move.b		d1,d2
	mulu		#POLY_LEN,d1
	adda.l		d1,a1		;point to first poly in buffer
	move.l		vscr,a0
	clr.l		d0
	clr.l		d1

	move.w		d4,d2

	asl.w		#2,d2		; d2 *= 4;

	move.w		0(a1,d2.W),d0
	move.w		2(a1,d2.W),d1

	clr.l		d2
	clr.l		d3
\ELP_loop:
	move.w		(a1)+,d2
	move.w		(a1)+,d3
	bsr		Fline0
	exg		d0,d2
	exg		d1,d3

	dbra		d4,\ELP_loop
\ELP_DEBUG_out
	
	movem.l		(sp)+,d0-d1/a0-a1
	bsr		Dec_pt_tail
	rts

;*******************************************************
DrawFirstPoly:
	movem.l		d0-d4/a0-a1,-(sp)
	
	bra		\DFP_SkipDebug
	
	move.l		#13,d0
	move.l		#13,d1
	move.l		#30,d2
	move.l		#30,d3
	clr.l		d4
	
	move.l		vscr,a0
	bsr		Fline
	bra		\DFP_DEBUG_out
\DFP_SkipDebug

	clr.l		d4
	move.b		pt_pntcnt,d4
;######--DBG
;	subq.w		#1,d4

	lea		poly_table,a1
	move.l		a1,a2
	clr.l		d1
	move.b		pt_head,d1
	clr.l		d2
	move.b		d1,d2
	mulu		#POLY_LEN,d1
	adda.l		d1,a1		;point to first poly in buffer
	move.l		vscr,a0
	clr.l		d0
	clr.l		d1

	move.w		d4,d2

	asl.w		#2,d2		; d2 *= 4;

	move.w		0(a1,d2.W),d0
	move.w		2(a1,d2.W),d1

	clr.l		d2
	clr.l		d3
\DFP_loop:
	move.w		(a1)+,d2
	move.w		(a1)+,d3
	bsr		Fline
	exg		d0,d2
	exg		d1,d3

	dbra		d4,\DFP_loop
\DFP_DEBUG_out
	movem.l		(sp)+,d0-d4/a0-a1
	rts


;*******************************************************
; Waiting for a line routine in prosit, so we can get rid of it...

Fline:                                          ;Thx to Jimmy Mardell
 movem.l d0-d7/a0,-(a7)
 cmp.w   d0,d2
 bcc DXpos
 exg d0,d2
 exg d1,d3
DXpos:
 move.w  d1,d4
 move.w  d1,d5
 lsl.w   #4,d4                 ;5
 lsl.w   #1,d5                 ;1
 sub.w   d5,d4
 move.w  d0,d5
 lsr.w   #3,d5
 add.w   d5,d4
 move.w  d0,d5
 not     d5
 and.b   #$07,d5
 adda    d4,a0
 bset.b  d5,(a0)
 move.b  d5,d6
 moveq   #1,d5
 lsl     d6,d5
 move.w  d2,d6
 sub.w   d0,d6
ChY:
 cmp.w   d1,d3
 bcc DYpos
 moveq   #-WordWidth,d4
 move.w  d1,d7
 sub.w   d3,d7
 bra PutP1
DYpos:
 moveq   #WordWidth,d4
 move.w  d3,d7
 sub.w   d1,d7
PutP1:           ; d4 = YAI, d5 = bit, d6 = DX, d7 = DY, A0 = Ptr
 cmp.w   d0,d2
 bne DotsNE
 cmp.w   d1,d3
 beq LineDone
DotsNE:
 cmp.w   d6,d7
 bcc DY_Greater
 move.l  d6,d2
 subq    #1,d2   ; d2 = number of pixels to be plot
 move.w  d7,d3
 sub.w   d6,d3   ; d3 = dy-dx
 asl.w   #1,d3   ; d3 = ai
 lsl.w   #1,d7   ; d7 = bi
 sub.w   d7,d6
 neg     d6      ; d6 = d
RepX:
 or.w    d6,d6
 bmi X_DNeg
 adda    d4,a0
 add.w   d3,d6
 bra IncX
X_DNeg:
 add.w   d7,d6
IncX:
 ror.b   #1,d5
 bcc X_SameByte
 addq    #1,a0
X_SameByte:
 or.b    d5,(a0)
 dbra    d2,RepX
 bra LineDone
DY_Greater:
 move.l  d7,d3
 subq    #1,d3   ; d3 = number of pixels to be plot
 move.w  d6,d2
 sub.w   d7,d2   ; d2 = dx-dy
 lsl.w   #1,d2   ; d2 = ai
 lsl.w   #1,d6   ; d6 = bi
 sub.w   d6,d7
 neg     d7      ; d7 = d
RepY:
 or.w    d7,d7
 bmi Y_DNeg
 ror.b   #1,d5
 bcc Y_SameByte
 addq    #1,a0
Y_SameByte:
 add.w   d2,d7
 bra IncY
Y_DNeg:
 add.w   d6,d7
IncY:
 adda    d4,a0
 or.b    d5,(a0)
 dbra    d3,RepY
LineDone:
 movem.l (a7)+,d0-d7/a0

 rts

;*******************************************************
Fline0:                                          ;Thx to Jimmy Mardell
 movem.l d0-d7/a0,-(a7)
 cmp.w   d0,d2
 bcc DXpos0
 exg d0,d2
 exg d1,d3
DXpos0:
 move.w  d1,d4
 move.w  d1,d5
 lsl.w   #4,d4                 ;5
 lsl.w   #1,d5                 ;1
 sub.w   d5,d4
 move.w  d0,d5
 lsr.w   #3,d5
 add.w   d5,d4
 move.w  d0,d5
 not     d5
 and.b   #$07,d5
 adda    d4,a0
 bclr.b  d5,(a0)
 move.b  d5,d6
 moveq   #1,d5
 lsl     d6,d5
 move.w  d2,d6
 sub.w   d0,d6
ChY0:
 cmp.w   d1,d3
 bcc DYpos0
 moveq   #-WordWidth,d4
 move.w  d1,d7
 sub.w   d3,d7
 bra PutP10
DYpos0:
 moveq   #WordWidth,d4
 move.w  d3,d7
 sub.w   d1,d7
PutP10:           ; d4 = YAI, d5 = bit, d6 = DX, d7 = DY, A0 = Ptr
 cmp.w   d0,d2
 bne DotsNE0
 cmp.w   d1,d3
 beq LineDone0
DotsNE0:
 cmp.w   d6,d7
 bcc DY_Greater0
 move.l  d6,d2
 subq    #1,d2   ; d2 = number of pixels to be plot
 move.w  d7,d3
 sub.w   d6,d3   ; d3 = dy-dx
 asl.w   #1,d3   ; d3 = ai
 lsl.w   #1,d7   ; d7 = bi
 sub.w   d7,d6
 neg     d6      ; d6 = d
RepX0:
 or.w    d6,d6
 bmi X_DNeg0
 adda    d4,a0
 add.w   d3,d6
 bra IncX0
X_DNeg0:
 add.w   d7,d6
IncX0:
 ror.b   #1,d5
 bcc X_SameByte0
 addq    #1,a0
X_SameByte0:
 not.b   d5
 and.b    d5,(a0)
 not.b   d5
 dbra    d2,RepX0
 bra LineDone0
DY_Greater0:
 move.l  d7,d3
 subq    #1,d3   ; d3 = number of pixels to be plot
 move.w  d6,d2
 sub.w   d7,d2   ; d2 = dx-dy
 lsl.w   #1,d2   ; d2 = ai
 lsl.w   #1,d6   ; d6 = bi
 sub.w   d6,d7
 neg     d7      ; d7 = d
RepY0:
 or.w    d7,d7
 bmi Y_DNeg0
 ror.b   #1,d5
 bcc Y_SameByte0
 addq    #1,a0
Y_SameByte0:
 add.w   d2,d7
 bra IncY0
Y_DNeg0:
 add.w   d6,d7
IncY0:
 adda    d4,a0
 not.b    d5
 and.b    d5,(a0)
 not.b    d5
 dbra    d3,RepY0
LineDone0:
 movem.l (a7)+,d0-d7/a0

 rts

;*******************************************************
 ifeq DEBUG_LEVEL-DEBUG
DEBUG_show_regs:
	move.l		d4,-(sp)
	movem.l		d0-d3/a0-a3,-(sp)
;d0 - d3
	move.l		(sp)+,d0
	move.l		#1,d1
	move.l		#1,d2
	move.l		#7,d4
	jsr		hexlib::put_hex
	move.l		(sp)+,d0
	move.l		#2,d1
	move.l		#1,d2
	move.l		#7,d4
	jsr		hexlib::put_hex
	move.l		(sp)+,d0
	move.l		#3,d1
	move.l		#1,d2
	move.l		#7,d4
	jsr		hexlib::put_hex
	move.l		(sp)+,d0
	move.l		#4,d1
	move.l		#1,d2
	move.l		#7,d4
	jsr		hexlib::put_hex
;a0 - a3
	move.l		(sp)+,d0
	move.l		#6,d1
	move.l		#1,d2
	move.l		#7,d4
	jsr		hexlib::put_hex
	move.l		(sp)+,d0
	move.l		#7,d1
	move.l		#1,d2
	move.l		#7,d4
	jsr		hexlib::put_hex
	move.l		(sp)+,d0
	move.l		#8,d1
	move.l		#1,d2
	move.l		#7,d4
	jsr		hexlib::put_hex
	move.l		(sp)+,d0
	move.l		#9,d1
	move.l		#1,d2
	move.l		#7,d4
	jsr		hexlib::put_hex


	move.l		(sp)+,d4

	BREAK_AND_COOPERATE

	rts


;*******************************************************


DEBUG_show_polytab:
	movem.l		d0-d3/a0-a3,-(sp)

;	lea		poly_table,a0
	lea		vectors,a0
;	lea		poly1,a0
	move.l		pt_polycnt,d0
	move.l		d0,a1
	move.w		#POLYORG_X,d1
	swap.l		d1
	move.w		#POLYORG_Y,d1
	move.l		d1,a2
	clr.l		d1
	move.w		speed,d1
	move.l		d1,a3
	move.l		(a0)+,d0
	move.l		(a0)+,d1
	move.l		(a0)+,d2
	move.l		(a0)+,d3
	bsr		DEBUG_show_regs

	BREAK_AND_COOPERATE

	movem.l		(sp)+,d0-d3/a0-a3
	rts
 endif  ;DEBUG
;*******************************************************

_exit:
Event_Quit:
	move.l		#Window1,-(sp)
	jsr		winlib::WinClose
	move.w		Prosit::CurrentProcessID,(sp)
	jsr		Prosit::Process_Terminate
	addq.l		#4,sp
	rts

;***********************************************************************


       EVEN
	dc.l    0

;***********************************************************************

	EVEN
w1rect	dc.w	WIN1_X,WIN1_Y,WIN1_X+WIN1_W-1,WIN1_Y+WIN1_H-1
cl_rect	dc.w	PCLIP_X1,PCLIP_Y1+7,PCLIP_X2,PCLIP_Y2+7

	EVEN
;WINDOW #1 STRUCTURE
window1:
lwgui	dc.l	w1gui	;Window GUI list
lwgotf	dc.l	w1foc	;"Window got focus" list
lwlostf	dc.l	w1nofoc	;"Window lost focus" list

;GUI LIST - FIRST ELEMENT
w1gui	dc.l	w1gui	;Only element in list => points to itself
	dc.w	0	;ID
	dc.b	127	;Priority
	dc.b	0	;Blank

;GUI MANAGEMENT PART
	dc.l	w1gfx
	dc.l	w1b1
	dc.w	1+RF_TRIG_RELEASE
	dc.l	w1b2
	dc.w	2+RF_TRIG_RELEASE
	dc.l	w1b3
	dc.w	3+RF_TRIG_RELEASE
	dc.l	w1b4
	dc.w	4+RF_TRIG_RELEASE
	dc.l	w1b5
	dc.w	5+RF_TRIG_RELEASE
	dc.l	w1b6
	dc.w	6+RF_TRIG_RELEASE
	dc.l	w1b7
	dc.w	7+RF_TRIG_RELEASE+RF_QUIT
	dc.l	w1b8
	dc.w	8+RF_TRIG_RELEASE
	dc.l	0

;GUI GRAPHICAL PART
w1gfx	dc.b	R_RECT,0,0,0,WIN1_W-1,WIN1_H-1
	dc.w	A_NORMAL
w1b1    dc.b    R_BUTTON,0,WIN1_W-6*(BUT_W+1)+2,WIN1_H-1*BUT_H-2,WIN1_W-6*(BUT_W+1)+2+BUT_W,WIN1_H-1*BUT_H-2+BUT_H
	dc.w	SMALL_TEXT_BUTTON
	dc.l	wbut1
w1b2    dc.b    R_BUTTON,0,WIN1_W-5*(BUT_W+1)+1,WIN1_H-1*BUT_H-2,WIN1_W-5*(BUT_W+1)+1+BUT_W,WIN1_H-1*BUT_H-2+BUT_H
	dc.w	SMALL_TEXT_BUTTON
	dc.l	wbut2
w1b3    dc.b    R_BUTTON,0,WIN1_W-4*(BUT_W+1)+1,WIN1_H-1*BUT_H-2,WIN1_W-4*(BUT_W+1)+1+BUT_W,WIN1_H-1*BUT_H-2+BUT_H
	dc.w	SMALL_TEXT_BUTTON
	dc.l	wbut3
w1b4    dc.b    R_BUTTON,0,WIN1_W-3*(BUT_W+1)-0,WIN1_H-1*BUT_H-2,WIN1_W-3*(BUT_W+1)-0+BUT_W,WIN1_H-1*BUT_H-2+BUT_H
	dc.w	SMALL_TEXT_BUTTON
	dc.l	wbut4
w1b5    dc.b    R_BUTTON,0,WIN1_W-2*(BUT_W+1)-0,WIN1_H-1*BUT_H-2,WIN1_W-2*(BUT_W+1)-0+BUT_W,WIN1_H-1*BUT_H-2+BUT_H
	dc.w	SMALL_TEXT_BUTTON
	dc.l	wbut5
w1b6    dc.b    R_BUTTON,0,WIN1_W-1*(BUT_W+1)-1,WIN1_H-1*BUT_H-2,WIN1_W-1*(BUT_W+1)-1+BUT_W,WIN1_H-1*BUT_H-2+BUT_H
	dc.w	SMALL_TEXT_BUTTON
	dc.l	wbut6
w1b7    dc.b    R_BUTTON,0,1,WIN1_H-1*BUT_H-2,1+BUT_W2,WIN1_H-1*BUT_H-2+BUT_H
	dc.w	SMALL_TEXT_BUTTON
	dc.l	wbut7
w1b8    dc.b    R_BUTTON,0,2+BUT_W2,WIN1_H-1*BUT_H-2,2+BUT_W2+BUT_W-4,WIN1_H-1*BUT_H-2+BUT_H
	dc.w	SMALL_TEXT_BUTTON
	dc.l	wbut8
	dc.b	-1


	EVEN
;"GOT FOCUS" LIST - FIRST ELEMENT
w1foc	dc.l	w1foc	;Only element in list => points to itself
	dc.w	0	;ID
	dc.b	127	;Priority
	dc.b	0	;Blank
;"GOT FOCUS" MANAGEMENT PART
	dc.l	w1fgfx
	dc.l	w1fgfx
	dc.w	0+RF_TRIG_RELEASE+RF_QUIT
	dc.l	w1ft
	dc.w	-1
	dc.l	0
;"GOT FOCUS" GRAPHICAL PART
w1fgfx	dc.b	R_BUTTON,0,0,0,6,6
	dc.w	PL_CENTERED+BU_FRAMED_BLACK+BU_GFX+A_REPLACE
	dc.l	clopen,clclose
w1ft	dc.b	R_BUTTON,0,7,1,WIN1_W-2,6
	dc.w	PL_LEFT_TOP+BU_TEXT+BU_FILLED_BLACK+A_REVERSE+BU_SMALL_FONT
	dc.b	"Lines",0

	dc.b	-1

	EVEN
;"LOST FOCUS" LIST - FIRST ELEMENT
w1nofoc	dc.l	w1nofoc	;Only element in list => points to itself
	dc.w	0	;ID
	dc.b	127	;Priority
	dc.b	0	;Blank
;"LOST FOCUS" MANAGEMENT PART
	dc.l	w1lfgfx
	dc.l	0
;"LOST FOCUS" GRAPHICAL PART
w1lfgfx	dc.b	R_FILL,0,1,1,WIN1_W-2,5
	dc.w	A_XOR
	dc.b	-1

;***********************************************************************

wbut1   dc.b    "L-",0
wbut2   dc.b    "L+",0
wbut3   dc.b    "P-",0
wbut4   dc.b    "P+",0
wbut5   dc.b    "S-",0
wbut6   dc.b    "S+",0
wbut7   dc.b    "Quit",0
wbut8   dc.b    "!",0

info1	dc.b	"Lines",0
info2	dc.b	"(c) 1999,",0
info3	dc.b	"Francois Revol",0
info4	dc.b	"revol@esisar.inpg.fr",0

        EVEN
clopen	dc.w	5,5
	dc.b	%11111000
	dc.b	%10101000
	dc.b	%11011000
	dc.b	%10101000
	dc.b	%11111000
	EVEN
clclose	dc.w	5,5
	dc.b	%00000000
	dc.b	%01010000
	dc.b	%00100000
	dc.b	%01010000
	dc.b	%00000000

_comment
        dc.b    "Prosit: "
wtitle1 dc.b    "Lines",0
        EVEN

	BSS
        EVEN

vscr		dc.l	0

speed		dc.w	0

pt_polycnt	dc.b	0
pt_pntcnt	dc.b	0
pt_head		dc.b	0
pt_tail		dc.b	0

EVEN

poly_table	ds.w	2*MAX_POINTS*(MAX_POLYS+1)
dummy1		ds.w	2		; Since i'm not sure of my code for now,
vectors		ds.w	2*MAX_POINTS
dummy2		ds.w	2		; here is a little protection against overflow
					; (to be fixed).

Window1		ds.b	W_HEADER_SIZE
	EVEN

Window_Datareturn:
Window_Dretrn:
Key		dc.w	0
MouseWindow	dc.w	0
MouseButton	dc.w	0
MouseX		dc.w	0
MouseY		dc.w	0
	CODE

	END
