;  pmag.asm - Prosit-Magnifier
;  (c) 1999, Franois Revol - revol@esisar.inpg.fr
;  Enjoy ;-)

;history:
;V0.1	28/07/99
;first version for Prosit 0.64
;status: OK
;
;V0.2	30/07/99
;Changed for Prosit v0.66
;status: not finished
;
;V1.0	04/09/99
;for Prosit V0.70.1
; *No functional changes
; *Removed DEBUG stuff
;status: OK
;

	include		"calc.h"

        include		"doorsos.h"
	include		"macros.h"
	include		"hexlib.h"
	include		"userlib.h"
	include		"prosit.h"
	include		"winlib.h"
	include		"keycodes.h"
;        include		"doorsosx.h"
; from doorsos.h_not_used: maybe I don't have the last version of DoorsOs...
A_REVERSE		equ	$0000
A_NORMAL		equ	$0001
A_XOR			equ	$0002
A_SHADED		equ	$0003
A_REPLACE		equ	$0004
A_OR			equ	$0005
A_AND			equ	$0006
A_THICK1		equ	$0007


	xdef		_prosit
	xdef    	_main
	xdef		_exit
	xdef		_comment

REAL_LCD_WIDTH		EQU	240
		; Yes, even for the TI89... (In compatibility mode ?)

WordWidth		EQU	8

WIN1_W                  EQU     WordWidth*8
WINDOW_WIDTH		EQU	WordWidth*8
WIN1_H                  EQU     7+WIN1_W+4
WINDOW_HEIGHT		EQU	7+WIN1_W+4
WIN1_X                  EQU     SCREEN_WIDTH-WIN1_W-5
WIN1_Y                  EQU     5

BUTTONS                 EQU     8
BUT_W                   EQU     12
BUT_W2                  EQU     24
BUT_H			EQU	9
BUT_S			EQU	BUT_H+1


PCLIP_X1		EQU	2
PCLIP_Y1		EQU	1
PCLIP_X2		EQU	WIN1_W-3
PCLIP_Y2		EQU	WIN1_H-20

NICE_VAL		EQU	40

MAG_FACTOR		EQU	4	; (Not used)

_prosit:
	HEADER_BEGIN
	DEFINE_PROSIT_VERSION	PROSIT_VERSION_STRING
	DEFINE_PROSIT_FILETYPE	PROSIT_FILETYPE_PROGRAM
	DEFINE_PROSIT_STACKSIZE	600
	DEFINE_PROSIT_EVENT	"quit",Event_Quit
	HEADER_END

_main:
	move.b		#0,Window1+W_FLAGS
	move.b		#0,Window1+W_PRIORITY
	pea		window1(pc)			;*Structure
	move.l		#Window_Datareturn,-(sp)	;*Return
	pea		w1rect(pc)			;*Window dimensions
	move.l		#Window1,-(sp)			;*Window
	jsr		winlib::WinOpen
	lea		16(sp),sp


	lea		Window1,a6
	move.w		W_CONTENTS_HANDLE(a6),d0
	doorsos::DEREF	d0,a6

	adda.l		#4,a6				;why ?
;;;	add.l		W_Y_OFFSET_IN_CONTENTS(a0),a6	;doesn't seem to work...
	adda.l		#7*WordWidth,a6	; Jump down below the title bar
	move.l		a6,vscr

		;Default params


Main_Loop:

		; Grab the screen
	bsr		Grab_Screen

		; We don't want a lot of CPU
	move.w		#NICE_VAL,d0
\NICE_loop
	BREAK_AND_COOPERATE
	dbra		d0,\NICE_loop

	move.l		#Window1,-(sp)		;Window
	jsr		winlib::Refresh_Window
	addq.l		#4,sp

	bra		Main_Loop

;*******************************************************

Grab_Screen:
	movem.l		d0-d5/a0-a3,-(sp)

	clr.l		d0
	clr.l		d1
	clr.w		d2

		; Inquire mouse coordinates

	move.w		winlib::MouseX,d0
	tst.w		d0
	bge		\GS_X_norm
	clr.w		d0
\GS_X_norm:

	move.w		winlib::MouseY,d1
	tst.w		d1
	bge		\GS_Y_norm
	clr.w		d1
\GS_Y_norm:
		; d0.w = X, d1.w = Y

		; Are there near the borders ?
		; If yes, correct them to keep the grab area in the screen

	cmp.w		#9,d1
	blt		\GS_Y_l1
	cmp.w		#SCREEN_HEIGHT-9,d1
	bgt		\GS_Y_l2
	bra		\GS_Y_skip
\GS_Y_l1:
	move.w		#8,d1
	bra		\GS_Y_skip
\GS_Y_l2:
	move.w		#SCREEN_HEIGHT-9,d1
\GS_Y_skip:

	subq.w		#8,d1

	cmp.w		#9,d0
	blt		\GS_X_l1
	cmp.w		#SCREEN_WIDTH-9,d0
	bgt		\GS_X_l2
	bra		\GS_X_skip
\GS_X_l1:
	move.w		#8,d0
	bra		\GS_X_skip
\GS_X_l2:
	move.w		#SCREEN_WIDTH-8,d0
\GS_X_skip:

	subq.w		#8,d0

	move.w		d0,d3
	asr.w		#3,d0		; X / 8

		; d0.w = X / 8, d1.w = Y d3.w = X

		; Screen Address

	move.l		#LCD_MEM,a0

	mulu		#REAL_LCD_WIDTH/8,d1

	adda.l		d1,a0

	adda.l		d0,a0

	move.l		vscr,a1

	move.w		d3,d4

	move.w		#16,d5

	; Here, we've:
	;	d0.l = data	d1.w = X % 8	d2.w = X / 8	d3.w = counter
	; 	a0 = scr_ptr	a1 = vscr_ptr


;	jsr		Prosit::Disable_Mouse	;one day, maybe ?
\GS_loop:
					; Word aligned ? not sure...
	clr.l		d0
	move.b		(a0),d0
	asl.l		#8,d0
	move.b		1(a0),d0
	asl.l		#8,d0
	move.b		2(a0),d0
	asl.l		#8,d0
	move.b		3(a0),d0

	andi.w		#7,d4
	lsl.l		d4,d0
	lsr.l		#8,d0
	lsr.l		#8,d0
	move.w		#6,d3
\GS_l1:
	bclr.l		#31,d1
	lsr.b		#1,d0
	bcc		\GS_s1
	bset.l		#31,d1
\GS_s1:
	asr.l		#4,d1
	dbra		d3,\GS_l1

	bclr.l		#31,d1
	lsr.b		#1,d0
	bcc		\GS_s1b
	bset.l		#31,d1
\GS_s1b:
	asr.l		#3,d1

	lsr.l		#8,d0
	move.w		#6,d3
\GS_l2:
	bclr.l		#31,d2
	lsr.b		#1,d0
	bcc		\GS_s2
	bset.l		#31,d2
\GS_s2:
	asr.l		#4,d2
	dbra		d3,\GS_l2

	bclr.l		#31,d2
	lsr.b		#1,d0
	bcc		\GS_s2b
	bset.l		#31,d2
\GS_s2b:
	asr.l		#3,d2

	bset.l		#31,d2
	ori.b		#1,d1
	move.l		d2,(a1)
	move.l		d1,4(a1)
	adda.l		#WordWidth,a1
	move.l		d2,(a1)
	move.l		d1,4(a1)
	adda.l		#WordWidth,a1
	move.l		d2,(a1)
	move.l		d1,4(a1)
	adda.l		#WordWidth,a1
	move.l		d2,(a1)
	move.l		d1,4(a1)

		; update pointers...
		; goto next line

	adda.l		#WordWidth,a1

	adda.l		#REAL_LCD_WIDTH/8,a0
	
	dbra		d5,\GS_loop
	suba.l		#WordWidth,a1
	move.l		#$FFFFFFFF,(a1)
	move.l		#$FFFFFFFF,4(a1)

;	jsr		Prosit::Enable_Mouse	;one day, maybe ?

	movem.l		(sp)+,d0-d5/a0-a3
	rts

;*******************************************************

_exit:
Event_Quit:
	move.l		#Window1,-(sp)
	jsr		winlib::WinClose
	move.w		Prosit::CurrentProcessID,(sp)
	jsr		Prosit::Process_Terminate


;***********************************************************************

	EVEN
w1rect	dc.w	WIN1_X,WIN1_Y,WIN1_X+WIN1_W-1,WIN1_Y+WIN1_H-1

	EVEN

;WINDOW #1 STRUCTURE
window1:
lwgui	dc.l	w1gui	;Window GUI list
lwgotf	dc.l	w1foc	;"Window got focus" list
lwlostf	dc.l	w1nofoc	;"Window lost focus" list

;GUI LIST - FIRST ELEMENT
w1gui	dc.l	w1gui	;Only element in list => points to itself
	dc.w	0	;ID
	dc.b	127	;Priority
	dc.b	0	;Blank

;GUI MANAGEMENT PART
	dc.l	w1gfx
	dc.l	0

;GUI GRAPHICAL PART
w1gfx	dc.b	R_RECT,0,0,0,WIN1_W-1,WIN1_H-1
	dc.w	A_NORMAL
	dc.b	-1

	EVEN
;"GOT FOCUS" LIST - FIRST ELEMENT
w1foc	dc.l	w1foc	;Only element in list => points to itself
	dc.w	0	;ID
	dc.b	127	;Priority
	dc.b	0	;Blank
;"GOT FOCUS" MANAGEMENT PART
	dc.l	w1fgfx
	dc.l	w1fgfx
	dc.w	0+RF_TRIG_RELEASE+RF_QUIT
	dc.l	w1ft
	dc.w	-1
	dc.l	0
;"GOT FOCUS" GRAPHICAL PART
w1fgfx	dc.b	R_BUTTON,0,0,0,6,6
	dc.w	PL_CENTERED+BU_FRAMED_BLACK+BU_GFX+A_REPLACE
	dc.l	clopen,clclose
w1ft	dc.b	R_BUTTON,0,7,1,WINDOW_WIDTH-2,6
	dc.w	PL_LEFT_TOP+BU_TEXT+BU_FILLED_BLACK+A_REVERSE+BU_SMALL_FONT
	dc.b	"PMag ",0

	dc.b	-1

	EVEN
;"LOST FOCUS" LIST - FIRST ELEMENT
w1nofoc	dc.l	w1nofoc	;Only element in list => points to itself
	dc.w	0	;ID
	dc.b	127	;Priority
	dc.b	0	;Blank
;"LOST FOCUS" MANAGEMENT PART
	dc.l	w1lfgfx
	dc.l	0
;"LOST FOCUS" GRAPHICAL PART
w1lfgfx	dc.b	R_FILL,0,1,1,WINDOW_WIDTH-2,5
	dc.w	A_XOR
	dc.b	-1



        EVEN
clopen	dc.w	5,5
	dc.b	%11111000
	dc.b	%10101000
	dc.b	%11011000
	dc.b	%10101000
	dc.b	%11111000
	EVEN
clclose	dc.w	5,5
	dc.b	%00000000
	dc.b	%01010000
	dc.b	%00100000
	dc.b	%01010000
	dc.b	%00000000

_comment
        dc.b    "Prosit: PMag",0
        EVEN
	BSS

	EVEN
vscr		dc.l	0

Window1		ds.b	W_HEADER_SIZE
	EVEN

Window_Dretrn:
Window_Datareturn:
Key		dc.w	0
MouseWindow	dc.w	0
MouseButton	dc.w	0
MouseX		dc.w	0
MouseY		dc.w	0
	CODE

	END
