;  posview.asm - Prosit-osview, system monitor
;  (c) 1999, Franois Revol - revol@esisar.inpg.fr
;  Enjoy ;-)

;history:
;V0.1	28/07/99
;first version for Prosit 0.64
;status: OK
;
;V0.2	30/07/99
;Changed for Prosit v0.66
;status: not finished
;
;V1.0	04/09/99
;for Prosit V0.70.1
; - No functional changes
; - Removed DEBUG stuff
;status: OK
;

	include		"calc.h"

        include		"doorsos.h"
	include		"macros.h"
	include		"hexlib.h"
	include		"userlib.h"
	include		"prosit.h"
	include		"winlib.h"
	include		"keycodes.h"
;        include		"doorsosx.h"
; from doorsos.h_not_used: maybe I don't have the last version of DoorsOs...
A_REVERSE		equ	$0000
A_NORMAL		equ	$0001
A_XOR			equ	$0002
A_SHADED		equ	$0003
A_REPLACE		equ	$0004
A_OR			equ	$0005
A_AND			equ	$0006
A_THICK1		equ	$0007
B_NORMAL		equ	$0010
B_ROUNDED		equ	$0020
B_DOUBLE		equ	$0040
B_CUT			equ	$0080

	xdef		_prosit
	xdef    	_main
	xdef		_exit
	xdef		_comment


WordWidth		EQU	7

WIN1_W                  EQU     WordWidth*8
WIN1_H                  EQU     57
WIN1_X                  EQU     SCREEN_WIDTH-WIN1_W-5
WIN1_Y                  EQU     5


;PCLIP_X1		EQU	2
;PCLIP_Y1		EQU	1
;PCLIP_X2		EQU	WIN1_W-3
;PCLIP_Y2		EQU	WIN1_H-20

TXT_ORG_X		EQU	2
TXT_ORG_Y		EQU	9
TXT_INT_Y			EQU	6

BOX_ORG_X		EQU	21
BOX_ORG_Y		EQU	TXT_ORG_Y
BOX_INT_Y		EQU	TXT_INT_Y
BOX_W			EQU	32
BOX_H			EQU	4
;BOX_FLAGS		EQU	BU_FILLED_WHITE+BU_FRAMED_BLACK
;BOXF_FLAGS		EQU	BU_FILLED_BLACK+BU_FRAMED_BLACK
;BOX_FLAGS		EQU	B_FILLED_WHITE+B_FRAMED_BLACK
;BOXF_FLAGS		EQU	B_FILLED_BLACK+B_FRAMED_BLACK
BOX_FLAGS		EQU	A_NORMAL
BOXF_FLAGS		EQU	A_NORMAL

LOAD_CAL		EQU	30
NICE_VAL		EQU	20

FREERAM_SAMP_INT	EQU	5
FRAM_MASK		EQU	$03FFFF
FRAM_SHIFT		EQU	13

BOX_W_OFF		EQU	6


_prosit:
	HEADER_BEGIN
	DEFINE_PROSIT_VERSION	PROSIT_VERSION_STRING
	DEFINE_PROSIT_FILETYPE	PROSIT_FILETYPE_PROGRAM
	DEFINE_PROSIT_STACKSIZE	600
	DEFINE_PROSIT_EVENT	"quit",Event_Quit
	HEADER_END

_main:
	move.b		#0,Window1+W_FLAGS
	move.b		#0,Window1+W_PRIORITY
	pea		window1(pc)			;*Structure
	move.l		#Window_Datareturn,-(sp)	;*Return
	pea		w1rect(pc)			;*Window dimensions
	move.l		#Window1,-(sp)			;*Window
	jsr		winlib::WinOpen
	lea		16(sp),sp

	tst.b		d0
	bne		err_win_exit
		;Not enough heap ?


		;Default params

	jsr		userlib::getfreeRAM
	move.l		d0,info_mem
	move.w		#FREERAM_SAMP_INT,fram_cnt

Main_Loop:

		; We don't want a lot of CPU

	move.w		#NICE_VAL,d0
\NICE_loop
	BREAK_AND_COOPERATE
	dbra		d0,\NICE_loop

		; We will measure the LOAD

	move.l		Prosit::Ticks,d1
	move.w		#LOAD_CAL,d0
\LOAD_loop
	BREAK_AND_COOPERATE
	dbra		d0,\LOAD_loop
	move.l		Prosit::Ticks,d2

	sub.l		d1,d2

		; Save it
	move.l		d2,info_load

		; Get Free Ram
	move.w		fram_cnt,d1
	dbra		d1,\FRAM_skip
	jsr		userlib::getfreeRAM
	move.l		d0,info_mem
	move.w		#FREERAM_SAMP_INT,d1
\FRAM_skip
	move.w		d1,fram_cnt

	bsr		DrawStats

	move.l          #Window1,-(sp)
	jsr             winlib::Refresh_Window
	addq.l          #4,sp

	bra		Main_Loop

;*******************************************************

DrawStats:
	movem.l		d0-d3/a0-a3,-(sp)
	lea		w1act,a0
	move.l		info_load,d0
	swap.l		d0
	tst.w		d0
	bne		\DS_LO_MAX
	swap.l		d0
	cmp.w		#32,d0
	bgt		\DS_LO_MAX
	bra		\DS_LO_skip
\DS_LO_MAX
	move.w		#32,d0
\DS_LO_skip
	add.w		#BOX_ORG_X,d0
	move.b		d0,w1bf1-w1act+4(a0)

	move.l		info_mem,d0
	andi.l		#FRAM_MASK,d0
	asr.l		#8,d0
	asr.l		#FRAM_SHIFT-8,d0
	neg.w		d0		; We want the used
	addi.w		#32,d0		; amount of RAM
	add.w		#BOX_ORG_X,d0
	move.b		d0,w1bf2-w1act+4(a0)
	


	move.l		a0,-(sp)
	move.l		#Window1,-(sp)
	jsr		winlib::DrawStructure
	addq		#8,sp
	movem.l		(sp)+,d0-d3/a0-a3
	rts

;*******************************************************

_exit:
Event_Quit:
	move.l		#Window1,-(sp)
	jsr		winlib::WinClose
err_win_exit:
	move.w		Prosit::CurrentProcessID,(sp)
	jsr		Prosit::Process_Terminate

;***********************************************************************

	EVEN
w1rect	dc.w	WIN1_X,WIN1_Y,WIN1_X+WIN1_W-1,WIN1_Y+WIN1_H-1

;------------------------------
	EVEN
;WINDOW #1 STRUCTURE
window1:
lwgui	dc.l	w1gui	;Window GUI list
lwgotf	dc.l	w1foc	;"Window got focus" list
lwlostf	dc.l	w1nofoc	;"Window lost focus" list

;GUI LIST - FIRST ELEMENT
w1gui	dc.l	w1gui	;Only element in list => points to itself
	dc.w	0	;ID
	dc.b	127	;Priority
	dc.b	0	;Blank

;GUI MANAGEMENT PART
	dc.l	w1gfx
	dc.l	0

;GUI GRAPHICAL PART
w1gfx	dc.b	R_RECT,0,0,0,WIN1_W-1,WIN1_H-1
	dc.w	A_NORMAL
w1t1	dc.b	R_BUTTON,0,TXT_ORG_X,TXT_ORG_Y,BOX_ORG_X,TXT_ORG_Y+BOX_H
	dc.w	BU_TEXT+PL_LEFT_CENTER+A_NORMAL+BU_SMALL_FONT
	dc.l	info1
w1t2	dc.b	R_BUTTON,0,TXT_ORG_X,TXT_ORG_Y+TXT_INT_Y,BOX_ORG_X,TXT_ORG_Y+TXT_INT_Y+BOX_H
	dc.w	BU_TEXT+PL_LEFT_CENTER+A_NORMAL+BU_SMALL_FONT
	dc.l	info2
w1t3	dc.b	R_BUTTON,0,TXT_ORG_X,TXT_ORG_Y+2*TXT_INT_Y,BOX_ORG_X,TXT_ORG_Y+2*TXT_INT_Y+BOX_H
	dc.w	BU_TEXT+PL_LEFT_CENTER+A_NORMAL+BU_SMALL_FONT
	dc.l	info3
w1t4	dc.b	R_BUTTON,0,TXT_ORG_X,TXT_ORG_Y+3*TXT_INT_Y,BOX_ORG_X,TXT_ORG_Y+3*TXT_INT_Y+BOX_H
	dc.w	BU_TEXT+PL_LEFT_CENTER+A_NORMAL+BU_SMALL_FONT
	dc.l	info4
	dc.b	-1

	EVEN
;"GOT FOCUS" LIST - FIRST ELEMENT
w1foc	dc.l	w1foc	;Only element in list => points to itself
	dc.w	0	;ID
	dc.b	127	;Priority
	dc.b	0	;Blank
;"GOT FOCUS" MANAGEMENT PART
	dc.l	w1fgfx
	dc.l	w1fgfx
	dc.w	0+RF_TRIG_RELEASE+RF_QUIT
	dc.l	w1ft
	dc.w	-1
	dc.l	0
;"GOT FOCUS" GRAPHICAL PART
w1fgfx	dc.b	R_BUTTON,0,0,0,6,6
	dc.w	PL_CENTERED+BU_FRAMED_BLACK+BU_GFX+A_REPLACE
	dc.l	clopen,clclose
w1ft	dc.b	R_BUTTON,0,7,1,WIN1_W-2,6
	dc.w	PL_LEFT_TOP+BU_TEXT+BU_FILLED_BLACK+A_REVERSE+BU_SMALL_FONT
	dc.l	wtitle1

	dc.b	-1

	EVEN
;"LOST FOCUS" LIST - FIRST ELEMENT
w1nofoc	dc.l	w1nofoc	;Only element in list => points to itself
	dc.w	0	;ID
	dc.b	127	;Priority
	dc.b	0	;Blank
;"LOST FOCUS" MANAGEMENT PART
	dc.l	w1lfgfx
	dc.l	0
;"LOST FOCUS" GRAPHICAL PART
w1lfgfx	dc.b	R_FILL,0,1,1,WIN1_W-2,5
	dc.w	A_XOR
	dc.b	-1

;------------------------------
;GUI Active LIST - (Graph bars)
	EVEN
w1act	dc.l	w1act	;Only element in list => points to itself
	dc.w	0	;ID
	dc.b	127	;Priority
	dc.b	0	;Blank

;GUI MANAGEMENT PART
	dc.l	w1agfx		;*graphical part
        dc.l    0

;GUI GRAPHICAL PART
w1agfx:

	dc.b	R_FILL,0,BOX_ORG_X,BOX_ORG_Y,BOX_ORG_X+BOX_W,BOX_ORG_Y+BOX_H
	dc.w	A_REVERSE
	dc.b	R_FILL,0,BOX_ORG_X,BOX_ORG_Y+BOX_INT_Y,BOX_ORG_X+BOX_W,BOX_ORG_Y+BOX_INT_Y+BOX_H
	dc.w	A_REVERSE
	dc.b	R_FILL,0,BOX_ORG_X,BOX_ORG_Y+2*BOX_INT_Y,BOX_ORG_X+BOX_W,BOX_ORG_Y+2*BOX_INT_Y+BOX_H
	dc.w	A_REVERSE
	dc.b	R_FILL,0,BOX_ORG_X,BOX_ORG_Y+3*BOX_INT_Y,BOX_ORG_X+BOX_W,BOX_ORG_Y+3*BOX_INT_Y+BOX_H
	dc.w	A_REVERSE

w1bn1	dc.b	R_RECT,0,BOX_ORG_X,BOX_ORG_Y,BOX_ORG_X+BOX_W,BOX_ORG_Y+BOX_H
	dc.w	BOX_FLAGS
w1bn2	dc.b	R_RECT,0,BOX_ORG_X,BOX_ORG_Y+BOX_INT_Y,BOX_ORG_X+BOX_W,BOX_ORG_Y+BOX_INT_Y+BOX_H
	dc.w	BOX_FLAGS
w1bn3	dc.b	R_RECT,0,BOX_ORG_X,BOX_ORG_Y+2*BOX_INT_Y,BOX_ORG_X+BOX_W,BOX_ORG_Y+2*BOX_INT_Y+BOX_H
	dc.w	BOX_FLAGS
w1bn4	dc.b	R_RECT,0,BOX_ORG_X,BOX_ORG_Y+3*BOX_INT_Y,BOX_ORG_X+BOX_W,BOX_ORG_Y+3*BOX_INT_Y+BOX_H
	dc.w	BOX_FLAGS

w1bf1	dc.b	R_FILL,0,BOX_ORG_X,BOX_ORG_Y,BOX_ORG_X+10,BOX_ORG_Y+BOX_H
	dc.w	BOXF_FLAGS
w1bf2	dc.b	R_FILL,0,BOX_ORG_X,BOX_ORG_Y+BOX_INT_Y,BOX_ORG_X+20,BOX_ORG_Y+BOX_INT_Y+BOX_H
	dc.w	BOXF_FLAGS
w1bf3	dc.b	R_FILL,0,BOX_ORG_X,BOX_ORG_Y+2*BOX_INT_Y,BOX_ORG_X+13,BOX_ORG_Y+2*BOX_INT_Y+BOX_H
	dc.w	BOXF_FLAGS
w1bf4	dc.b	R_FILL,0,BOX_ORG_X,BOX_ORG_Y+3*BOX_INT_Y,BOX_ORG_X+25,BOX_ORG_Y+3*BOX_INT_Y+BOX_H
	dc.w	BOXF_FLAGS
	dc.b	-1

        EVEN
info1	dc.b	"Load",0
info2	dc.b	"Mem",0
info3	dc.b	"Frag",0
info4	dc.b	"Ints",0

        EVEN
clopen	dc.w	5,5
	dc.b	%11111000
	dc.b	%10101000
	dc.b	%11011000
	dc.b	%10101000
	dc.b	%11111000
	EVEN
clclose	dc.w	5,5
	dc.b	%00000000
	dc.b	%01010000
	dc.b	%00100000
	dc.b	%01010000
	dc.b	%00000000

	EVEN
_comment
        dc.b    "Prosit: "
wtitle1 dc.b    "POsView",0
        EVEN
	BSS

	EVEN

fram_cnt	dc.w	0

info_table:
info_load	dc.l	0
info_mem	dc.l	0
info_frag	dc.l	0
info_ints	dc.l	0


Window1		ds.b	W_HEADER_SIZE
	EVEN

Window_Dretrn:
Window_Datareturn:
Key		dc.w	0
MouseWindow	dc.w	0
MouseButton	dc.w	0
MouseX		dc.w	0
MouseY		dc.w	0
	CODE

	END
